<?php if (!defined('PmWiki')) exit();

    $out = array();
    $txtdbOutFmt = $class = '';

    if(in_array('transpose', $outbehaviour)) { $data = txtdb_array_transpose($data); }

    if(in_array('sortable', $outbehaviour)) {
      $class = 'sortable simpletable';
    }
    $otid1 = isset($drawparams['id']) ? trim($drawparams['id']) : '';
    $class = isset($drawparams['class']) ? $class.' '.@$drawparams['class'] : $class;

    $prefix = isset($drawparams['prefix']) ? $drawparams['prefix'] : '';  #todo
    $suffix = isset($drawparams['suffix']) ? $drawparams['suffix'] : '';  #todo

    if(isset($class)) trim($class); $class = "class=\"$class\"";
    if(isset($otid)) trim($otid); $otid = "id=\"$otid1\"";

    if(
       strtolower(@$drawparams[''][1]) === 'wikitable'
      ) {

      //============== wikitable table-sortable #todo
      $GLOBALS['RedoMarkupLine']++;

      $out[] = "|| $otid $class"; $o = '';
      if( ! in_array('transpose', $outbehaviour)) {
        $out[] = "\n".'||! ' . implode(' ||! ', $result->colNames) . ' ||';
      }
      foreach($data as $v) {
        foreach($v as $val) {
          if(trim($val) == '') { $val = ' '; } $o .= $prefix.$val.$suffix . '||'; }
        $out[] = "\n" . '||' . $o; $o = '';
      }
      $txtdbOutFmt =  implode('', $out);
      $txtdbOutFmt = str_replace('##', " \\\\"."\n", $txtdbOutFmt);
      //==============

      if($txtdbOutFmt != "") {
        $txtdbOutFmt =  (
          "\n" . $txtdbOutFmt . "\n"
        );
      }

    }

    if(
       strtolower(@$drawparams[''][1]) === 'table'
      ) {

      //============== html table-sortable
      $out[] = "<table $otid $class width='98%' border='0' cellpadding='0' cellspacing='0'>";
      if( ! in_array('transpose', $outbehaviour)) {
        $out[] = "\n".'<tr><th>' . implode('</th><th>', $result->colNames) . '</th></tr>';
      }
      foreach($data as $v) { $out[] = "\n".'<tr><td>' . implode('</td><td>', $v) . '</td></tr>'; }
      $out[] = '</table>';
      $txtdbOutFmt = implode('',$out);
      $txtdbOutFmt = str_replace('##', "<br />", $txtdbOutFmt);
      //==============

      if($txtdbOutFmt != "") {
        $txtdbOutFmt = keep(
          "\n<!--txtdb id $id ".@$otid1."-->\n" . $txtdbOutFmt . "\n<!--/txtdb id $id ".@$otid1."-->"
        );
      }

    }

    unset($out);
    unset($data);

